<script setup lang="ts">
import { useBranchStore } from '@/stores/branch'
import { useStockStore } from '@/stores/stock'
import type { Stock } from '@/types/Stock'
import { computed, nextTick, onMounted, reactive, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const usestockStore = useStockStore()
const usebranchStore = useBranchStore()
const dialog = ref(false)
const form = ref(false)
const loading = ref(false)
const dialogDelete = ref(false)
const dialogEdit = ref(false)
const dialogEditCheck = ref(false)
const dialogEditImport = ref(false)
const dialogCheckStock = ref(false)
const dialogImportStock = ref(false)
const dialogCheckAvaStock = ref(false)
const dialogCheckLowStock = ref(false)
const dialogCheckOutStock = ref(false)

const refForm = ref<VForm | null>(null)

const headers = [
  {
    title: 'Stock ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Stock Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Min',
    key: 'min',
    value: 'min'
  },
  {
    title: 'Balance',
    key: 'balance',
    value: 'balance'
  },
  {
    title: 'Unit',
    key: 'unit',
    value: 'unit'
  },
  {
    title: 'Status(auto)',
    key: 'status',
    value: 'status'
  },
  {
    title: 'Actions',
    key: 'actions',
    sortable: false
  }
]

const headers2 = [
  {
    title: 'Stock ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Stock Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Min',
    key: 'min',
    value: 'min'
  },
  {
    title: 'Balance',
    key: 'balance',
    value: 'balance'
  },
  {
    title: 'Unit',
    key: 'unit',
    value: 'unit'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  {
    title: 'Actions',
    key: 'actions',
    sortable: false
  }
]

function onSubmit() {}

onMounted(() => {
  usestockStore.getStocks()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    usestockStore.clearForm()
  })
}
function closeDialogEdit() {
  dialogEdit.value = false
  nextTick(() => {
    usestockStore.clearForm()
  })
}
function closeDialogEditCheck() {
  dialogEditCheck.value = false
  nextTick(() => {
    usestockStore.clearForm()
  })
}
function closeDialogEditImport() {
  dialogEditImport.value = false
  nextTick(() => {
    usestockStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usestockStore.saveStock()
  closeDialog()
}

async function saveEdit() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usestockStore.saveStock()
  closeDialogEdit()
}

async function saveEditCheck() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usestockStore.saveStock()
  closeDialogEditCheck()
}

async function saveEditImport() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usestockStore.saveStock()
  closeDialogEditImport()
}

async function editItem(item: Stock) {
  if (!item.id) return
  await usestockStore.getStock(item.id)
  dialog.value = true
}
async function edit(item: Stock) {
  if (!item.id) return
  await usestockStore.getStock(item.id)
  dialogEdit.value = true
}
async function CheckItem(item: Stock) {
  if (!item.id) return
  await usestockStore.getStock(item.id)
  dialogEditCheck.value = true
}
async function ImportItem(item: Stock) {
  if (!item.id) return
  await usestockStore.getStock(item.id)
  dialogEditImport.value = true
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    usestockStore.clearForm()
  })
}
async function deleteItemConfirm() {
  await usestockStore.deleteStock()
  closeDelete()
}
async function deleteItem(item: Stock) {
  if (!item.id) return
  await usestockStore.getStock(item.id)
  dialogDelete.value = true
}
function openCheckStockDialog() {
  dialogCheckStock.value = true
}
function closeCheckStockDialog() {
  dialogCheckStock.value = false
}
function openImporStockDialog() {
  dialogImportStock.value = true
}
function closeImporStockDialog() {
  dialogImportStock.value = false
}

// Check Status

function openCheckAvaStockDialog() {
  dialogCheckAvaStock.value = true
}
function closeCheckAvaStockDialog() {
  dialogCheckAvaStock.value = false
}

function openCheckLowStockDialog() {
  dialogCheckLowStock.value = true
}
function closeCheckLowStockDialog() {
  dialogCheckLowStock.value = false
}

function openCheckOutStockDialog() {
  dialogCheckOutStock.value = true
}
function closeCheckOutStockDialog() {
  dialogCheckOutStock.value = false
}
</script>

<template>
  <div>
    <!-- กล่องสรุปข้อมูล -->
    <v-container>
      <v-row>
        <v-col
          ><v-card height="130px" style="background-color: #4ca8ff" class="overviewStock">
            <v-card-title>Total Product</v-card-title>
            <div style="padding-left: 30px">
              {{ usestockStore.totalStocks }}
              <v-icon end icon="mdi-archive" size="60px" style="padding-left: 130px"></v-icon>
            </div> </v-card
        ></v-col>
        <v-col
          ><v-card
            height="130px"
            style="background-color: #5eb966"
            class="overviewStock"
            @click="openCheckAvaStockDialog"
          >
            <v-card-title>Available</v-card-title>
            <div style="padding-left: 30px">
              {{ usestockStore.totalAvailableStocks }}
              <v-icon
                end
                icon="mdi-checkbox-marked-circle"
                size="60px"
                style="padding-left: 130px"
              ></v-icon>
            </div> </v-card
        ></v-col>
        <v-col
          ><v-card
            height="130px"
            style="background-color: #f4a833"
            class="overviewStock"
            @click="openCheckLowStockDialog"
          >
            <v-card-title>Low Stock</v-card-title>
            <div style="padding-left: 30px">
              {{ usestockStore.totalLowStocks }}
              <v-icon end icon="mdi-alert" size="60px" style="padding-left: 130px"></v-icon>
            </div> </v-card
        ></v-col>
        <v-col
          ><v-card
            height="130px"
            style="background-color: #e94344"
            class="overviewStock"
            @click="openCheckOutStockDialog"
          >
            <v-card-title>Out of Stock</v-card-title>
            <div style="padding-left: 30px">
              {{ usestockStore.totalOutStocks }}
              <v-icon end icon="mdi-close-circle" size="60px" style="padding-left: 130px"></v-icon>
            </div> </v-card
        ></v-col>
      </v-row>
    </v-container>

    <v-data-table :headers="headers" :items="usestockStore.searchStock" class="custom-datatable">
      <template v-slot:top>
        <v-toolbar style="background-color: #4b382a; height: auto" dark flat>
          <v-toolbar-title style="color: white">
            <v-text-field
              class="mr-4"
              prepend-inner-icon="mdi-magnify"
              v-model="usestockStore.search"
              label="Search"
              style="height: 60px; margin-top: 4px"
            ></v-text-field>
          </v-toolbar-title>
          <v-divider class="mr-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited  Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                style="background-color: white; margin-right: 16px"
                @click="openImporStockDialog"
              >
                Import material
              </v-btn>
              <v-btn
                style="background-color: white; margin-right: 16px"
                @click="openCheckStockDialog"
              >
                Check material
              </v-btn>
              <v-btn
                prepend-icon="mdi-plus"
                style="background-color: green; color: white; margin-right: 16px"
                v-bind="props"
              >
                New material
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Stock Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12">
                        <v-text-field
                          v-model="usestockStore.editedStock.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="6" sm="6">
                        <v-text-field
                          v-model.number="usestockStore.editedStock.min"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Min"
                          placeholder="Enter your min"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="6">
                        <v-text-field
                          v-model.number="usestockStore.editedStock.balance"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Balance"
                          placeholder="Enter your balance"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="6">
                        <v-combobox
                          label="Unit"
                          :items="['Kilogram', 'Gram', 'Liter', 'Milliliter', 'piece']"
                          v-model="usestockStore.editedStock.unit"
                          variant="solo-filled"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="6" sm="6">
                        <v-combobox
                          label="Status"
                          :items="['Available', 'Low', 'Out of Stock']"
                          v-model="usestockStore.editedStock.status"
                          variant="solo-filled"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="6">
                        <v-img
                          :src="
                            'http://localhost:4000/images/stocks/' + usestockStore.editedStock.image
                          "
                          width="200"
                        ></v-img>
                      </v-col>
                      <v-col cols="6">
                        <v-file-input
                          v-model="usestockStore.editedStock.files"
                          :rules="[
                            (value) => {
                              return (
                                !value ||
                                !value.length ||
                                value[0].size < 2000000 ||
                                'Avatar size should be less than 2 MB!'
                              )
                            }
                          ]"
                          accept="image/png, image/jpeg, image/bmp"
                          label="Image"
                          placeholder="Pick an image"
                          prepend-icon="mdi-camera"
                        ></v-file-input>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card class="center-card" elevation="5">
              <v-icon
                icon="mdi-alert-circle-outline"
                size="110px"
                style="margin-top: 5%; color: rgba(255, 151, 4, 1)"
              ></v-icon>
              <v-card-text>Are you sure you want to delete this item?</v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  style="background-color: rgba(223, 50, 46, 1); color: white"
                  rounded="lg"
                  @click="closeDelete"
                  ><span style="color: white">Cancel</span></v-btn
                >
                <v-btn
                  style="background-color: rgba(45, 133, 219, 1); color: white"
                  rounded="lg"
                  @click="deleteItemConfirm"
                  ><span style="color: white">OK</span></v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
              <div style="margin-bottom: 5%"></div>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="edit(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:4000/images/stocks/' + item.image" width="100"></v-img>
      </template>
    </v-data-table>
  </div>
  <v-dialog v-model="dialogEdit" max-width="500px">
    <v-card>
      <v-card-title>
        <v-icon end icon="mdi-file-document-edit-outline" size="30px"></v-icon
        ><span class="text-h5"> Edit Stock </span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  v-model="usestockStore.editedStock.name"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Name"
                ></v-text-field>
              </v-col>
              <v-col cols="6" sm="6">
                <v-text-field
                  v-model="usestockStore.editedStock.min"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Min"
                  placeholder="Enter your min"
                ></v-text-field>
              </v-col>
              <v-col cols="6" sm="6">
                <v-combobox
                  label="Unit"
                  :items="['Kilogram', 'Gram', 'Liter', 'Milliliter', 'piece']"
                  v-model="usestockStore.editedStock.unit"
                  variant="solo-filled"
                ></v-combobox>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialogEdit"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="saveEdit()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogEditCheck" max-width="500px">
    <v-card>
      <v-card-title>
        <v-icon end icon="mdi-file-document-edit-outline" size="30px"></v-icon
        ><span class="text-h5"> Edit Checkstock </span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="6" sm="6">
                <v-text-field
                  v-model="usestockStore.editedStock.balance"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Balance"
                  placeholder="Enter your balance"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialogEditCheck"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="saveEditCheck()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <!-- Main Check Dialog -->
  <v-dialog v-model="dialogCheckStock" max-width="1000px">
    <v-card>
      <v-card-title class="subDialog"
        ><v-icon end icon="mdi-file-document-edit-outline" size="30px"></v-icon> Check
        Stock</v-card-title
      >
      <v-data-table
        :headers="headers2"
        :items="usestockStore.searchStock"
        :items-per-page="7"
        class="sub-datatable"
      >
        <template v-slot:[`item.actions`]="{ item }">
          <v-icon size="small" class="me-2" @click="CheckItem(item)">mdi-pencil</v-icon>
        </template>
      </v-data-table>
      <v-card-actions style="background-color: rgba(114, 87, 42, 1)">
        <v-spacer></v-spacer>
        <v-btn
          color="white"
          @click="closeCheckStockDialog"
          elevation="4"
          width="200"
          variant="outlined"
          >Close</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogEditImport" max-width="500px">
    <v-card>
      <v-card-title>
        <v-icon end icon="mdi-file-document-edit-outline" size="30px"></v-icon
        ><span class="text-h5"> Edit Import </span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col class="text-h9">
                <span class="text-h7"> Min </span>
                <div>{{ usestockStore.editedStock.min }}</div>
              </v-col>
              <v-col cols="6" sm="6">
                <v-text-field
                  v-model="usestockStore.editedStock.balance"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Import new balance"
                  placeholder="Enter your balance"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialogEditImport"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="saveEditImport()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <!-- Main Import Dialog -->
  <v-dialog v-model="dialogImportStock" max-width="1000px">
    <v-card style="color: #4b382a">
      <v-card-title class="subDialog"
        ><v-icon end icon="mdi-package-down" size="30px"></v-icon> Import Stock</v-card-title
      >
      <v-data-table
        :headers="headers2"
        :items="usestockStore.searchStock"
        :items-per-page="7"
        class="sub-datatable"
      >
        <template v-slot:[`item.actions`]="{ item }">
          <v-icon size="small" class="me-2" @click="ImportItem(item)">mdi-pencil</v-icon>
        </template>
      </v-data-table>
      <v-card-actions style="background-color: rgba(114, 87, 42, 1)">
        <v-spacer></v-spacer>
        <v-btn
          color="white"
          @click="closeImporStockDialog"
          elevation="4"
          width="200"
          variant="outlined"
          >Close</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- Show Low Stock Dialog -->
  <v-dialog v-model="dialogCheckLowStock" max-width="1000px">
    <v-card style="background-color: rgb(236, 175, 35)">
      <v-card-title class="showStatusDialog">Low Stock</v-card-title>
      <v-data-table
        :headers="headers2"
        :items="usestockStore.lowStocks"
        :items-per-page="5"
        style="background-color: rgba(255, 245, 212, 1)"
        class="headers-datatable"
      ></v-data-table>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          @click="closeCheckLowStockDialog"
          color="white"
          elevation="4"
          width="200"
          variant="outlined"
          >Close</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- Show Available Stock Dialog -->
  <v-dialog v-model="dialogCheckAvaStock" max-width="1000px">
    <v-card style="background-color: rgba(113, 175, 124, 1)">
      <v-card-title class="showStatusDialog">Available Stock</v-card-title>
      <v-data-table
        :headers="headers2"
        :items="usestockStore.availableStocks"
        :items-per-page="5"
        style="background-color: rgba(234, 244, 213, 1)"
        class="headers-datatable"
      ></v-data-table>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          @click="closeCheckAvaStockDialog"
          color="white"
          elevation="4"
          width="200"
          variant="outlined"
          >Close</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- Show Out of Stock Dialog -->
  <v-dialog v-model="dialogCheckOutStock" max-width="1000px">
    <v-card style="background-color: rgb(208, 90, 90)">
      <v-card-title class="showStatusDialog">Out of Stock Stock</v-card-title>
      <v-data-table
        :headers="headers2"
        :items="usestockStore.outStocks"
        :items-per-page="5"
        style="background-color: rgba(247, 228, 228, 1)"
        class="headers-datatable"
      ></v-data-table>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          @click="closeCheckOutStockDialog"
          color="white"
          elevation="4"
          width="200"
          variant="outlined"
          >Close</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style>
.center-card {
  display: flex;
  justify-content: center;
  align-items: center;
}

.custom-datatable {
  & th {
    background-color: rgba(174, 167, 160, 1);
    color: white;
    font-weight: bold;
  }

  & tbody tr:nth-child(even) {
    background-color: rgba(244, 238, 226, 1);
  }

  & tbody tr:nth-child(odd) {
    background-color: rgba(234, 227, 217, 1);
  }
}

.sub-datatable {
  & th {
    color: black;
    font-weight: bold;
  }

  background-color: rgb(253, 241, 227);
}

.headers-datatable {
  & th {
    color: black;
    font-weight: bold;
  }
}

.overviewStock {
  font-family: 'Kanit';
  font-size: 55px;
  font-weight: bold;
  color: white;
  text-align: left;
}

.subDialog {
  font-family: 'Kanit';
  font-size: 30px;
  color: white;
  text-align: center;
  background-color: rgba(114, 87, 42, 1);
}

.showStatusDialog {
  font-family: 'Kanit';
  font-size: 30px;
  color: white;
  text-align: center;
}
</style>
